(*

Guru.eXe^tMX presents...
 -  "myPEFile"

<     PE  >
{ This procedures used in SCANiT! }
<                >

:
    -    
   PE  ,   
      PE .

  :
  if CheckPEfile('myfile.exe') then
  mytext.caption:= GetImageBase('myfile.exe');

  ():
  1.     myPEFile ,
   ,       
    , .. : ModulInformation.
         
        .
         
     , .. Guru.eXe.  
       myPEFile.
  2.  ,     myPEFile,
      - Guru.eXe
         
  -     .
  3.   /   
      .
  4.     
    myPEFile.
  5.        
       myPEFile  
   .
  6.      , 
        
   .

Copyright [c] 2005-2006 by Guru.eXe
(e-mail: DarkGuru@pisem.net)

*)


unit myPEFile;

interface
uses Windows, SysUtils, Classes, Messages;

 type
  TSection = packed record
   Name: array[0..7] of Char;
   VirtualSize: DWORD;
   VirtualAddress: DWORD;
   PhysicalSize: DWORD;
   PhysicalOffset: DWORD;
   PointerToRelocations: DWORD;
   PointerToLinenumbers: DWORD;
   NumberOfRelocations: WORD;
   NumberOfLinenumbers: WORD;
   Characteristics: DWORD;
 end;

 type
  TOpenPEFileName = packed record
    lStructSize: DWORD;
    hWndOwner: HWND;
    hInstance: HINST;
    lpstrFilter: PAnsiChar;
    lpstrCustomFilter: PAnsiChar;
    nMaxCustFilter: DWORD;
    nFilterIndex: DWORD;
    lpstrFile: PAnsiChar;
    nMaxFile: DWORD;
    lpstrFileTitle: PAnsiChar;
    nMaxFileTitle: DWORD;
    lpstrInitialDir: PAnsiChar;
    lpstrTitle: PAnsiChar;
    Flags: DWORD;
    nFileOffset: Word;
    nFileExtension: Word;
    lpstrDefExt: PAnsiChar;
    lCustData: LPARAM;
    lpfnHook: function(Wnd: HWND; Msg: UINT; wParam: WPARAM;
    lParam: LPARAM): UINT stdcall;
    lpTemplateName: PAnsiChar;
  end;

var
 f: file;
 Section: TSection;
 FHandle: THandle;
 OFS: OFSTRUCT;
 ChePESig: DWORD;
 BytesRead: DWORD;
 PEHeaderOffset: DWORD;   { $3C }
 ImageBase: DWORD;        { $34 }
 EntryPointRVA: DWORD;    { $28 }
 NumOfSections: WORD;     { $06 }
 Link_Major: BYTE;        { $1A }
 Link_Minor: BYTE;        { $1B }
 SubSystem: DWORD;        { $5C }
 EntryPointOffset: DWORD; { $F8 }
 SizeOfImage: DWORD;      { $50 }
 Sect_Align: DWORD;       { $38 }
 Inst, hWnd: Integer;
 FileName: array[0..4095] of Char;

const
 OFN_LONGNAMES     = $00200000;
 OFN_EXPLORER      = $00080000;
 OFN_FILEMUSTEXIST = $00001000;
 OFN_PATHMUSTEXIST = $00000800;
 OFN_HIDEREADONLY  = $00000004;


 //select file...
 function SelectFile: string;
 function SelectCheckPEfile: boolean;
 //information
 procedure ModulInformation;
 //Check for valid PE file
 function CheckPEfile(FilName: string): boolean;
 //Check for Armadillo Linker Version
 function CheckArmadilloLinker(filname: string): boolean;
 //"GET" functions
 function GetImageBase(FilName: string): string;
 function GetEPrva(Filname: string): string;
 function GetSecNumb(filname: string): string;
 function GetLinkerVer(filname: string): string;
 function GetSubSysByte(filname: string): string;
 function GetSubSysPEiD(filname: string): string;
 function GetOEP(filname: string): string;
 function GetEPoffset(filname: string): string;
 function GetSecName(filname: string; SectionNum: integer): string;
 function GetSecVSize(filname: string; SectionNum: integer): string;
 function GetSecVOffs(filname: string; SectionNum: integer): string;
 function GetSecPSize(filname: string; SectionNum: integer): string;
 function GetSecPOffs(filname: string; SectionNum: integer): string;
 function GetSecCharact(filname: string; SectionNum: integer): string;
 //Generate Section Name
 function GetRandomSecName: string;
 function GetPackerSecName: string;
 //"SET" functions
 function SetSecName(filname: string; SectionNum: integer; SecName: string): boolean;
 function SetZiroDate(filname: string): boolean;
 function SetZiroLinkerVer(filname: string): boolean;
 //UPX Scrambler (bonus!)
 function UPXScrambler(filname: string): boolean;
 //Add New Section
 function AddSection(filname: string; SecName: string): boolean;

implementation

 function GetOpenFileNameA(var OpenFile: TOpenPEFileName): Bool; stdcall;
 external 'comdlg32.dll' name 'GetOpenFileNameA';

procedure ModulInformation;
const jmp= #13#10;
begin
 MessageBox(0, 'myPEFile Ver 1.2a'+jmp+jmp+
                 'Author: Guru.eXe^tMX'+jmp+
                 'Email: DarkGuru@pisem.net'+jmp+
                 'Web: http://www.team-x.ru'+jmp+jmp+
                 'Than YOU for USE!', 'Information...', MB_ICONINFORMATION);
end;

function OpenPE(FName: string): boolean;
begin
 result:=false;
  AssignFile(f, Fname);
  if not FileExists(FName) then exit;
  FHandle:= OpenFile(PChar(FName), OFS, OF_READWRITE);
  SetFilePointer(FHandle, $3C, nil, 0);
  ReadFile(FHandle, PEHeaderOffset, SizeOf(PEHeaderOffset), BytesRead, nil);
 result:=true;
end;

function SelectFile: string;
const
  Filter = 'PE File (*.exe,*.dll)'#0'*.exe;*.scr;*.dll;*.ocx';
  Title  = 'Open PE File...';
var
  OpenFile : TOpenPEFileName;
begin
  FillChar(OpenFile, SizeOf(TOpenPEFileName), 0);

  with OpenFile do begin
    lStructSize:= SizeOf(TOpenPEFileName);
    hInstance:= Inst;
    hWndOwner:= hWnd;
    lpstrFilter:= Filter;
    nFilterIndex:= 3;
    nMaxFile:= SizeOf(FileName);
    lpstrFile:= FileName;
    lpstrTitle:= Title;
    Flags:= OFN_LONGNAMES or OFN_EXPLORER or OFN_FILEMUSTEXIST or
            OFN_PATHMUSTEXIST or OFN_HIDEREADONLY;

    if GetOpenFileNameA(OpenFile) = true then begin
       result:=FileName;
    end;
  end;
end;

function CheckPEFile(Filname: string): boolean;
begin
 result:=false;
  if not openpe(filname) then exit;
//  SetFilePointer(FHandle, $3C, nil, 0);
//  ReadFile(FHandle, PEHeaderOffset, SizeOf(PEHeaderOffset), BytesRead, nil);
  if PEHeaderOffset = 0 then Exit;
  SetFilePointer(FHandle, PEHeaderOffset, nil, 0);
  ReadFile(FHandle, ChePESig, SizeOf(ChePESig), BytesRead, nil);
  if ChePESig <> $00004550 then Exit;
  CloseHandle(FHandle);
 result:=true;
end;

function SelectCheckPEFile: boolean;
begin
 result:=false;
  if not CheckPEFile(selectFile) then exit;
 result:=true;
end;

function GetImageBase(FilName: string): string;
var output: string;
begin
  if not openpe(filname) then exit;
  SetFilePointer(FHandle, PEHeaderOffset + $34, nil, 0);
  ReadFile(FHandle, ImageBase, SizeOf(ImageBase), BytesRead, nil);
  output:=IntToHex(ImageBase,8);
  CloseHandle(FHandle);
 result:=output;
end;

function GetEPrva(Filname: string): string;
var output: string;
begin
  if not openpe(filname) then exit;
  SetFilePointer(FHandle, PEHeaderOffset + $28, nil, 0);
  ReadFile(FHandle, EntryPointRVA, SizeOf(EntryPointRVA), BytesRead, nil);
  output:=IntToHex(EntryPointRVA,8);
  CloseHandle(FHandle);
 result:=output;
end;

function GetSecNumb(filname: string): string;
begin
  if not openpe(filname) then exit;
  SetFilePointer(FHandle, PEHeaderOffset + $06, nil, 0);
  ReadFile(FHandle, NumOfSections, SizeOf(NumOfSections), BytesRead, nil);
  CloseHandle(FHandle);
 result:=IntToStr(NumOfSections);
end;

function GetLinkerVer(filname: string): string;
var Linker_Version: string;
begin
  if not openpe(filname) then exit;
   SetFilePointer(FHandle, PEHeaderOffset + $1A, nil, 0);
   ReadFile(FHandle, Link_Major, SizeOf(Link_Major), BytesRead, nil);
   SetFilePointer(FHandle, PEHeaderOffset + $1B, nil, 0);
   ReadFile(FHandle, Link_Minor, SizeOf(Link_Minor), BytesRead, nil);
   Linker_Version:=IntToStr(Link_Major)+'.'+IntToStr(Link_Minor);
  CloseHandle(FHandle);
 result:=linker_Version;
end;

function GetSubSysByte(filname: string): string;
begin
  if not openpe(filname) then exit;
  SetFilePointer(FHandle, PEHeaderOffset + $5C, nil, 0);
  ReadFile(FHandle, subsystem, SizeOf(subsystem), BytesRead, nil);
  CloseHandle(FHandle);
 result:=IntToHex(subsystem,2);
end;

function GetSubSysPEiD(filname: string): string;
var output: string;
begin
  if GetSubSysByte(filname) = '01' then
   output:='No subsystem'  else
  if GetSubSysByte(filname) = '05' then
   output:='OS/2 console'  else
  if GetSubSysByte(filname) = '07' then
   output:='Posix console' else
  if GetSubSysByte(filname) = '03' then
   output:='Win32 concole' else
  if GetSubSysByte(filname) = '02' then
   output:='Win32 GUI'     else
   output:='Unknown subsystem';
 result:=output;
end;

function CheckArmadilloLinker(filname: string): boolean;
begin
 if GetLinkerVer(filname)='83.82' then
 result:=true else result:=false;
end;

function GetOEP(filname: string): string;
var
output:DWORD;
begin
  if not openpe(filname) then exit;
  SetFilePointer(FHandle, PEHeaderOffset + $28, nil, 0);
  ReadFile(FHandle, EntryPointRVA, SizeOf(EntryPointRVA), BytesRead, nil);
  SetFilePointer(FHandle, PEHeaderOffset + $34, nil, 0);
  ReadFile(FHandle, ImageBase, SizeOf(ImageBase), BytesRead, nil);
  CloseHandle(FHandle);
  output:=ImageBase+EntryPointRVA;
  result:=IntToHex(output,8);
end;

function GetEPoffset(filname: string): string;
var I: DWORD;
begin
  if not openpe(filname) then exit;

  SetFilePointer(FHandle, PEHeaderOffset + $28, nil, 0);
  ReadFile(FHandle, EntryPointRVA, SizeOf(EntryPointRVA), BytesRead, nil);

  SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
  for I:= 1 to NumOfSections do
  begin
    ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
    if (EntryPointRVA >= Section.VirtualAddress)
      and (EntryPointRVA < Section.VirtualAddress + Section.VirtualSize) then Break;
  end;
  EntryPointOffset:= EntryPointRVA - Section.VirtualAddress + Section.PhysicalOffset;
  CloseHandle(FHandle);
  result:=IntToHex(EntryPointOffset,8);
end;

function GetSecName(filname: string; SectionNum:integer): string;
var n:integer;
  max:integer;
begin
if not openpe(filname) then exit;

SetFilePointer(FHandle, PEHeaderOffset + $06, nil, 0);
ReadFile(FHandle, NumOfSections, SizeOf(NumOfSections), BytesRead, nil);
max:=NumOfSections;

if SectionNum <= max then
begin
 SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
 for n:= 1 to SectionNum do
  begin
   ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
  end;
 CloseHandle(FHandle);
 result:=section.Name;
end;
end;

function GetSecVSize(filname: string; SectionNum:integer): string;
var n:integer;
  max:integer;
begin
if not openpe(filname) then exit;

SetFilePointer(FHandle, PEHeaderOffset + $06, nil, 0);
ReadFile(FHandle, NumOfSections, SizeOf(NumOfSections), BytesRead, nil);
max:=NumOfSections;

if SectionNum <= max then
begin
SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
for n:= 1 to SectionNum do
begin
ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
end;
CloseHandle(FHandle);
result:=IntToHex(section.VirtualSize,8);
end;
end;

function GetSecVOffs(filname: string; SectionNum:integer): string;
var n:integer;
  max:integer;
begin
if not openpe(filname) then exit;

SetFilePointer(FHandle, PEHeaderOffset + $06, nil, 0);
ReadFile(FHandle, NumOfSections, SizeOf(NumOfSections), BytesRead, nil);
max:=NumOfSections;

if SectionNum <= max then
begin
SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
for n:= 1 to SectionNum do
begin
ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
end;
CloseHandle(FHandle);
result:=IntToHex(section.VirtualAddress,8);
end;
end;

function GetSecPSize(filname: string; SectionNum:integer): string;
var n:integer;
  max:integer;
begin
if not openpe(filname) then exit;
SetFilePointer(FHandle, PEHeaderOffset + $06, nil, 0);
ReadFile(FHandle, NumOfSections, SizeOf(NumOfSections), BytesRead, nil);
max:=NumOfSections;

if SectionNum <= max then
begin
SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
for n:= 1 to SectionNum do
begin
ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
end;
CloseHandle(FHandle);
result:=IntToHex(section.PhysicalSize,8);
end;
end;

function GetSecPOffs(filname: string; SectionNum:integer): string;
var n:integer;
  max:integer;
begin
if not openpe(filname) then exit;
SetFilePointer(FHandle, PEHeaderOffset + $06, nil, 0);
ReadFile(FHandle, NumOfSections, SizeOf(NumOfSections), BytesRead, nil);
max:=NumOfSections;

if SectionNum <= max then
begin
SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
for n:= 1 to SectionNum do
begin
ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
end;
CloseHandle(FHandle);
result:=IntToHex(section.PhysicalOffset,8);
end;
end;

function GetSecCharact(filname: string; SectionNum:integer): string;
var n:integer;
  max:integer;
begin
 if not openpe(filname) then exit;
 SetFilePointer(FHandle, PEHeaderOffset + $06, nil, 0);
 ReadFile(FHandle, NumOfSections, SizeOf(NumOfSections), BytesRead, nil);
 max:=NumOfSections;
 if SectionNum <= max then
  begin
   SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
  for n:= 1 to SectionNum do
   begin
    ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
   end;
  CloseHandle(FHandle);
  result:=IntToHex(section.Characteristics,8);
 end;
end;

function SetSecName(filname: string; SectionNum: integer; SecName: string): boolean;
var n:integer;
  max:integer;
begin
 result:=false;
  if not openpe(filname) then exit;
   SetFilePointer(FHandle, PEHeaderOffset + $06, nil, 0);
   ReadFile(FHandle, NumOfSections, SizeOf(NumOfSections), BytesRead, nil);
   max:=NumOfSections;
  if SectionNum <= max then
   begin
    SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
     for n:= 1 to SectionNum do
      begin
       ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
       SetFilePointer(FHandle, -SizeOf(Section), nil, FILE_CURRENT);
       if length(SecName) > 8 then exit;
          StrPCopy(section.name,SecName);
       WriteFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
      end;
     CloseHandle(FHandle);
   result:=true;
  end;
end;

function GetPackerSecName: string;
const
 sectname: array [0..33] of ShortString =('ASPack','.aspr',
  '.code','kryptor','.lame','Guard','.shrink','.UPX1',
  'PELockNT','PESHLD','Stone','.peshit','PEtite','SC v1.2',
  '.shield','SPLASH','SVKP','tElock','CDLock','.UPX2',
  'HYBRIS','.lcc','Xtreme','.pepack','ZCode','.PECrypt',
  'ORiEN','.y0da','PUNiSHER','.stealth','.UPX0','.PKLITE',
  '.arma','.nfo');
var rend:integer;
begin
  Randomize;
  rend:=random(33);
  result:=sectname[rend];
end;

function GetRandomSecName: string;
var sectname: array [1..8] of String;
begin
  Randomize;
  sectname[1]:= inttostr (random(10));
  sectname[2]:= inttostr (random(10));
  sectname[3]:= inttostr (random(10));
  sectname[4]:= inttostr (random(10));
  sectname[5]:= inttostr (random(10));
  sectname[6]:= inttostr (random(10));
  sectname[7]:= inttostr (random(10));
  result:='.'+sectname[1]+sectname[2]+sectname[3]+
  sectname[4]+sectname[5]+sectname[6]+sectname[7];
end;

function SetZiroLinkerVer(filname: string): boolean;
var lver: DWORD;
begin
 result:=false;
  if not openpe(filname) then exit;

  lver:= 0;
  SetFilePointer(FHandle, PEHeaderOffset + $1A, nil, 0);
  WriteFile(FHandle, lver, SizeOf(lver), BytesRead, nil);
  WriteFile(FHandle, lver, SizeOf(lver), BytesRead, nil);

  CloseHandle(FHandle);
 result:=true;
end;

function SetZiroDate(filname: string): boolean;
var dat: DWORD;
begin
 result:=false;
  if not openpe(filname) then exit;

  dat:= 0;
  SetFilePointer(FHandle, PEHeaderOffset + $08, nil, 0);
  WriteFile(FHandle, dat, SizeOf(dat), BytesRead, nil);

  CloseHandle(FHandle);
 result:=true;
end;

function UPXScrambler(filname: string): boolean;
var
    I: DWORD;
 ziro: Byte;
const
  NOP: Byte = $90;
begin
 result:=false;
  if not openpe(filname) then exit;

  SetFilePointer(FHandle, PEHeaderOffset + $28, nil, 0);
  ReadFile(FHandle, EntryPointRVA, SizeOf(EntryPointRVA), BytesRead, nil);

  SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
  for I:= 1 to NumOfSections do
  begin
    ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
    if (EntryPointRVA >= Section.VirtualAddress)
      and (EntryPointRVA < Section.VirtualAddress + Section.VirtualSize) then Break;
  end;
  EntryPointOffset:= EntryPointRVA - Section.VirtualAddress + Section.PhysicalOffset;

  SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
  ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
  SetFilePointer(FHandle, Section.PhysicalOffset - 37, nil, 0);

  Ziro:= 0;
  for I:= 1 to 37 do
   WriteFile(FHandle, Ziro, SizeOf(Ziro), BytesRead, nil);
   SetFilePointer(FHandle, EntryPointOffset, nil, 0);
   WriteFile(FHandle, NOP, SizeOf(NOP), BytesRead, nil);

  CloseHandle(FHandle);
 result:=true;
end;

function AddSection(filname: string; SecName:string): boolean;
const Ziro: Byte = $00;
      BI_VA: DWord = $00;
      BI_Size: DWord = $00;
var  I,ImSz,N,VirAddr,PhyAddr: DWORD;
begin
 result:=false;
  if not openpe(filname) then exit;

  if length(SecName) > 8 then exit;

  SetFilePointer(FHandle, PEHeaderOffset + $50, nil, 0);
  ReadFile(FHandle, SizeOfImage, SizeOf(SizeOfImage), BytesRead, nil);

  SetFilePointer(FHandle, PEHeaderOffset + $38, nil, 0);
  ReadFile(FHandle, Sect_Align, SizeOf(Sect_Align), BytesRead, nil);

  SetFilePointer(FHandle, PEHeaderOffset + $06, nil, 0);
  ReadFile(FHandle, NumOfSections, SizeOf(NumOfSections), BytesRead, nil);

  SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
  for I:= 1 to NumOfSections do
  begin
    ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
  end;

    VirAddr:=((section.VirtualAddress+section.VirtualSize+Sect_Align-1) div Sect_Align) * Sect_Align;
    PhyAddr:=section.PhysicalOffset+section.PhysicalSize;


  SetFilePointer(FHandle, PEHeaderOffset + $F8 + NumOfSections * $28 - $28, nil, 0);
  ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
  with Section do
  begin
    VirtualAddress:=VirAddr;
    PhysicalOffset:=PhyAddr;
    VirtualSize:= $1000;
    PhysicalSize:= $200;
    Characteristics:= $E00000E0;
    StrPCopy(name,SecName);
  end;
  //    BoundImport';  sniperZ
  SetFilePointer(FHandle,PEHeaderOffset+$D0, nil, 0);
  WriteFile(FHandle, BI_VA, SizeOf(BI_VA), BytesRead, nil);
  SetFilePointer(FHandle,PEHeaderOffset+$D4, nil, 0);
  WriteFile(FHandle, BI_Size, SizeOf(BI_Size), BytesRead, nil);
  //
  SetFilePointer(FHandle, PEHeaderOffset + $50, nil, 0);
  ImSZ:=SizeOfImage+Section.VirtualSize;
  WriteFile(FHandle, ImSz, SizeOf(ImSz), BytesRead, nil);

  SetFilePointer(FHandle, PEHeaderOffset + $F8 + NumOfSections * $28, nil, 0);
  WriteFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
   Inc(NumOfSections);
  SetFilePointer(FHandle, PEHeaderOffset + $06, nil, 0);
  WriteFile(FHandle, NumOfSections, SizeOf(NumOfSections), BytesRead, nil);

  SetFilePointer(FHandle, Section.PhysicalOffset + Section.PhysicalSize -
    $200, nil, 0);

  for N:=1 to Section.PhysicalSize do
  WriteFile(FHandle, Ziro, SizeOf(Ziro), BytesRead, nil);

  CloseHandle(FHandle);
 result:=true;
end;
end.





